# -*- coding: utf-8 -*-
# Create your views here.

from django.contrib.auth.decorators import login_required
from django.http import Http404
from django.shortcuts import render_to_response, get_object_or_404
from django.template import RequestContext

from DjangoWS.rating.forms import *
from DjangoWS.rating.models import *

def voteinfo_helper(updateuser):
	try:
		vi = updateuser.voteinfo
	except:
		vi = Voteinfo()
		vi.user = updateuser

	sum = 0
	for v in Vote.objects.filter(votefor=updateuser):
		sum += v.tux
	vi.count = Vote.objects.filter(votefor=updateuser).count()
	vi.average = float(sum) / float(Vote.objects.filter(votefor=updateuser).count())
	vi.save()



def overview(Request):
	users = User.objects.all().order_by('-voteinfo__average')
	return render_to_response('rating/overview.html', locals(), RequestContext(Request))



@login_required()
def vote(Request, uid=0, tux=0):
	uid = int(uid)
	tux = int(tux)
	if uid != 0:
		if tux<1 or tux>5:
			raise Http404

		uservotedfor = get_object_or_404(User, pk=uid)
		if Vote.objects.filter(voter=Request.user, votefor=uservotedfor).count() == 0:
			vote = Vote()
			vote.voter = Request.user
			vote.votefor = uservotedfor
			vote.tux = tux
			vote.save()
			Request.user.message_set.create(message=u'Für %s wurden %d Tux(e) eingetragen!' % (uservotedfor.username, tux))
		else:
			Request.user.message_set.create(message=u'Du hast schon für %s abgestimmt!' % uservotedfor.username)

		voteinfo_helper(uservotedfor)

	users = User.objects.all().order_by('username')
	return render_to_response('rating/vote.html', locals(), RequestContext(Request))



@login_required()
def change(Request, vid=''):

	if not vid.isdigit():
		votes = Vote.objects.filter(voter=Request.user)
		return render_to_response('rating/change.html', locals(), RequestContext(Request))
	else:
		vid = int(vid)
		vote = get_object_or_404(Vote, pk=vid)
		if Request.method == 'POST':
			form = VoteForm(Request.POST, instance=vote)
			if form.is_valid():
				form.save()
				Request.user.message_set.create(message=u'Stimme geändert!')

				voteinfo_helper(vote.votefor)

			else:
				Request.user.message_set.create(message="Fehler in übergebenen Daten!")
		else:
			form = VoteForm(instance=vote)

		return render_to_response('rating/change.html', locals(), RequestContext(Request))


